/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.configurazione.test;

import java.util.Iterator;
import java.util.Set;

import org.hibernate.Session;

import it.eng.configurazione.bean.ConnetionParameter;
import it.eng.configurazione.bean.DataSource;
import it.eng.configurazione.bean.ExtractionProcess;
import it.eng.configurazione.bean.Field;
import it.eng.configurazione.bean.Interface;
import it.eng.configurazione.bean.Operation;
import it.eng.configurazione.bean.OperationParameter;
import it.eng.configurazione.bean.SourceType;
import it.eng.configurazione.service.ConfigurationDAO;
import it.eng.configurazione.service.HibernateUtils;
import junit.framework.TestCase;

public class OperationTest extends TestCase {

	DataSource dataSourceTest=null;
	SourceType tipo=null;
	Interface interfacciaTest=null;
	Operation operazione=null;
	ExtractionProcess processo=null;
	Session sessione= HibernateUtils.getSession();
	public OperationTest(String name) {
		super(name);
		
	}

	public void testLetturaExtractionProcess() {
		ConfigurationDAO dao=new ConfigurationDAO();
		ExtractionProcess tmp=dao.readExtractionProcess("PROCESSO_JIRA");
		assertEquals(tmp.getName(), processo.getName());
		assertEquals(tmp.getId(), processo.getId());

	}	
	
	private boolean contain(ConnetionParameter c, Set<ConnetionParameter> insieme){
		Iterator<ConnetionParameter> iter=insieme.iterator();
		while (iter.hasNext()){
			ConnetionParameter tmp=iter.next();
			if (c.getName().equals(tmp.getName()) && c.getValue().equals(tmp.getValue()))return true;
		}
		return false;
	}

}
