/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.eng.extractors.jira.rpc;

public class RemotePermissionScheme  extends it.eng.extractors.jira.rpc.RemoteScheme  implements java.io.Serializable {
    private it.eng.extractors.jira.rpc.RemotePermissionMapping[] permissionMappings;

    public RemotePermissionScheme() {
    }

    public RemotePermissionScheme(
           java.lang.String description,
           java.lang.Long id,
           java.lang.String name,
           java.lang.String type,
           it.eng.extractors.jira.rpc.RemotePermissionMapping[] permissionMappings) {
        super(
            description,
            id,
            name,
            type);
        this.permissionMappings = permissionMappings;
    }


    /**
     * Gets the permissionMappings value for this RemotePermissionScheme.
     * 
     * @return permissionMappings
     */
    public it.eng.extractors.jira.rpc.RemotePermissionMapping[] getPermissionMappings() {
        return permissionMappings;
    }


    /**
     * Sets the permissionMappings value for this RemotePermissionScheme.
     * 
     * @param permissionMappings
     */
    public void setPermissionMappings(it.eng.extractors.jira.rpc.RemotePermissionMapping[] permissionMappings) {
        this.permissionMappings = permissionMappings;
    }

    private java.lang.Object __equalsCalc = null;
    public synchronized boolean equals(java.lang.Object obj) {
        if (!(obj instanceof RemotePermissionScheme)) return false;
        RemotePermissionScheme other = (RemotePermissionScheme) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = super.equals(obj) && 
            ((this.permissionMappings==null && other.getPermissionMappings()==null) || 
             (this.permissionMappings!=null &&
              java.util.Arrays.equals(this.permissionMappings, other.getPermissionMappings())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = super.hashCode();
        if (getPermissionMappings() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getPermissionMappings());
                 i++) {
                java.lang.Object obj = java.lang.reflect.Array.get(getPermissionMappings(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(RemotePermissionScheme.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("http://beans.soap.rpc.jira.atlassian.com", "RemotePermissionScheme"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("permissionMappings");
        elemField.setXmlName(new javax.xml.namespace.QName("", "permissionMappings"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://beans.soap.rpc.jira.atlassian.com", "RemotePermissionMapping"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
